• LeetCode第一题—— Two Sum(寻找两数,要求和为target)


    题目描述:

    Given an array of integers, return indices of the two numbers such that they add up to a specific target.

    You may assume that each input would have exactly one solution, and you may not use the same element twice.

    Example:

    Given nums = [2, 7, 11, 15], target = 9,
    
    Because nums[0] + nums[1] = 2 + 7 = 9,
    return [0, 1].

    My solution(50ms,38.5MB)

    class Solution {
        public int[] twoSum(int[] nums, int target) {
            int[] result = new int[2];
            for(int i=0;i<nums.length;i++){
                for(int j=i+1;j<nums.length;j++){
                    if(nums[i]+nums[j]==target){
                        result[0] = i;
                        result[1] = j;
                    }
                }
            }
            return result;
        }
    }

    以下是标准答案

    Approach 1: Brute Force(16ms,38.5MB)

    class Solution {
        public int[] twoSum(int[] nums, int target) {
            for (int i = 0; i < nums.length; i++) {
                for (int j = i + 1; j < nums.length; j++) {
                    if (nums[j] == target - nums[i]) {
                        return new int[] { i, j };
                    }
                }
            }
            throw new IllegalArgumentException("No two sum solution");
       }
    }

    Approach 2: Two-pass Hash Table(2ms,38.1MB)

    class Solution {
          public int[] twoSum(int[] nums, int target) {
              Map<Integer, Integer> map = new HashMap<>();
              for (int i = 0; i < nums.length; i++) {
                  map.put(nums[i], i);
              }
              for (int i = 0; i < nums.length; i++) {
                  int complement = target - nums[i];
                  if (map.containsKey(complement) && map.get(complement) != i) {
                      return new int[] { i, map.get(complement) };
                  }
              }
              throw new IllegalArgumentException("No two sum solution");
          }
    }

    Approach 3: One-pass Hash Table(2ms,38.2MB)

    class Solution {
        public int[] twoSum(int[] nums, int target) {
            Map<Integer, Integer> map = new HashMap<>();
            for (int i = 0; i < nums.length; i++) {
                int complement = target - nums[i];
                if (map.containsKey(complement)) {//判断键名是否包含complement
                    return new int[] { map.get(complement), i };
                }
                map.put(nums[i], i);
            }
            throw new IllegalArgumentException("No two sum solution");
        }
    }
  • 相关阅读:
    [转载]Bat语法
    [转载]白手起家学习使用flex
    [转载]Highcharts结合Asp.net实现动态数据股票式图形显示实例
    [转]uploadify3.0详细使用说明
    转帖:UML实践用例图、顺序图、状态图、类图、包图、协作图
    [转]JQuery操作Table
    [转]Chrome developer tool介绍(javascript调试)
    [转载]C# 指针之美
    [转载]C# 温故而知新: 线程篇(二)
    [转载]Javascript定义类(class)的三种方法
  • 原文地址:https://www.cnblogs.com/mgblog/p/10653391.html
Copyright © 2020-2023  润新知